Index: /GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp
===================================================================
--- /GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 1014)
+++ /GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 1019)
@@ -1,4 +1,4 @@
 #include "GeoTreeSimplifier.h"
-#include "Hoja.h"
+#include "Leaf.h"
 
 #include <iostream>
@@ -87,5 +87,5 @@
 /*	std::map<float,int> hojas_x_crit;
 	for (int i=0; i<countLeaves; i++)
-		hojas_x_crit[Leaves[i].criterio] = i;
+		hojas_x_crit[Leaves[i].criteria] = i;
 
 	int *leaf_order = new int[countLeaves];
@@ -167,5 +167,5 @@
 
 	if (countLeaves > 0)
-		Leaves = new Hoja[2*countLeaves];
+		Leaves = new Leaf[2*countLeaves];
 
 	activeLeaves = countLeaves;
@@ -191,15 +191,15 @@
 		v2=mesh->mSubMesh[meshLeaves].mIndex[j+1];
 		v3=mesh->mSubMesh[meshLeaves].mIndex[j+2];
-		Leaves[pos].Vert_Hoja[0]=v1;
-		Leaves[pos].Vert_Hoja[1]=v2;
-		Leaves[pos].Vert_Hoja[2]=v3;
-		Leaves[pos].id_triangulo[0]=triangleID;
-		Leaves[pos].existe=true;
+		Leaves[pos].vertsLeaf[0]=v1;
+		Leaves[pos].vertsLeaf[1]=v2;
+		Leaves[pos].vertsLeaf[2]=v3;
+		Leaves[pos].idTriangle[0]=triangleID;
+		Leaves[pos].exists=true;
 		triangleID++;
 
 		// second triangle
 		v3=mesh->mSubMesh[meshLeaves].mIndex[j+5];
-		Leaves[pos].Vert_Hoja[3]=v3;
-		Leaves[pos].id_triangulo[1]=triangleID;
+		Leaves[pos].vertsLeaf[3]=v3;
+		Leaves[pos].idTriangle[1]=triangleID;
 		triangleID++;
 
@@ -228,5 +228,5 @@
 
 // Calculates the center of a leaf
-void TreeSimplifier::CalculateLeafCenter(Hoja &auxleaf)
+void TreeSimplifier::CalculateLeafCenter(Leaf &auxleaf)
 {
 	float	max_x;
@@ -238,34 +238,34 @@
 	
 	//x1
-	max_x	=	max(max(Vertex[auxleaf.Vert_Hoja[0]][0],Vertex[auxleaf.Vert_Hoja[1]][0]),
-				    max(Vertex[auxleaf.Vert_Hoja[2]][0],Vertex[auxleaf.Vert_Hoja[3]][0]));
-	
-	min_x	=	min(min(Vertex[auxleaf.Vert_Hoja[0]][0],Vertex[auxleaf.Vert_Hoja[1]][0]),
-				  	min(Vertex[auxleaf.Vert_Hoja[2]][0],Vertex[auxleaf.Vert_Hoja[3]][0]));
-
-	auxleaf.Centro[0] = (max_x + min_x)/2;
+	max_x	=	max(max(Vertex[auxleaf.vertsLeaf[0]][0],Vertex[auxleaf.vertsLeaf[1]][0]),
+				    max(Vertex[auxleaf.vertsLeaf[2]][0],Vertex[auxleaf.vertsLeaf[3]][0]));
+	
+	min_x	=	min(min(Vertex[auxleaf.vertsLeaf[0]][0],Vertex[auxleaf.vertsLeaf[1]][0]),
+				  	min(Vertex[auxleaf.vertsLeaf[2]][0],Vertex[auxleaf.vertsLeaf[3]][0]));
+
+	auxleaf.center[0] = (max_x + min_x)/2;
 
 	//y1
-	max_y	=	max(max(Vertex[auxleaf.Vert_Hoja[0]][1],Vertex[auxleaf.Vert_Hoja[1]][1]),
-				  	max(Vertex[auxleaf.Vert_Hoja[2]][1],Vertex[auxleaf.Vert_Hoja[3]][1]));
-	
-	min_y	=	min(min(Vertex[auxleaf.Vert_Hoja[0]][1],Vertex[auxleaf.Vert_Hoja[1]][1]),
-				  	min(Vertex[auxleaf.Vert_Hoja[2]][1],Vertex[auxleaf.Vert_Hoja[3]][1]));
-
-	auxleaf.Centro[1]	=	(max_y + min_y) / 2;
+	max_y	=	max(max(Vertex[auxleaf.vertsLeaf[0]][1],Vertex[auxleaf.vertsLeaf[1]][1]),
+				  	max(Vertex[auxleaf.vertsLeaf[2]][1],Vertex[auxleaf.vertsLeaf[3]][1]));
+	
+	min_y	=	min(min(Vertex[auxleaf.vertsLeaf[0]][1],Vertex[auxleaf.vertsLeaf[1]][1]),
+				  	min(Vertex[auxleaf.vertsLeaf[2]][1],Vertex[auxleaf.vertsLeaf[3]][1]));
+
+	auxleaf.center[1]	=	(max_y + min_y) / 2;
 	
 	//z1
-	max_z	=	max(max(Vertex[auxleaf.Vert_Hoja[0]][2],Vertex[auxleaf.Vert_Hoja[1]][2]),
-				  	max(Vertex[auxleaf.Vert_Hoja[2]][2],Vertex[auxleaf.Vert_Hoja[3]][2]));
-	
-	min_z	=	min(min(Vertex[auxleaf.Vert_Hoja[0]][2],Vertex[auxleaf.Vert_Hoja[1]][2]),
-				  	min(Vertex[auxleaf.Vert_Hoja[2]][2],Vertex[auxleaf.Vert_Hoja[3]][2]));
-
-	auxleaf.Centro[2]	=	(max_z + min_z) / 2;
+	max_z	=	max(max(Vertex[auxleaf.vertsLeaf[0]][2],Vertex[auxleaf.vertsLeaf[1]][2]),
+				  	max(Vertex[auxleaf.vertsLeaf[2]][2],Vertex[auxleaf.vertsLeaf[3]][2]));
+	
+	min_z	=	min(min(Vertex[auxleaf.vertsLeaf[0]][2],Vertex[auxleaf.vertsLeaf[1]][2]),
+				  	min(Vertex[auxleaf.vertsLeaf[2]][2],Vertex[auxleaf.vertsLeaf[3]][2]));
+
+	auxleaf.center[2]	=	(max_z + min_z) / 2;
 }
 
 
 //  calculate the normal vector of a leaf
-void TreeSimplifier::CalculateLeafNormal(Hoja &auxleaf)
+void TreeSimplifier::CalculateLeafNormal(Leaf &auxleaf)
 {
 	float onex, oney, onez;
@@ -273,11 +273,11 @@
 	float threex, threey, threez;
 
-	onex   = Vertex[auxleaf.Vert_Hoja[0]][0]; oney   = Vertex[auxleaf.Vert_Hoja[0]][1]; onez   = Vertex[auxleaf.Vert_Hoja[0]][2];
-	twox   = Vertex[auxleaf.Vert_Hoja[1]][0]; twoy   = Vertex[auxleaf.Vert_Hoja[1]][1]; twoz   = Vertex[auxleaf.Vert_Hoja[1]][2];
-	threex = Vertex[auxleaf.Vert_Hoja[2]][0]; threey = Vertex[auxleaf.Vert_Hoja[2]][1]; threez = Vertex[auxleaf.Vert_Hoja[2]][2];
-	
-	auxleaf.Normal[0] = ((twoz-onez)*(threey-oney)) - ((twoy-oney)*(threez-onez));
-	auxleaf.Normal[1] = ((twox-onex)*(threez-onez)) - ((threex-onex)*(twoz-onez));
-	auxleaf.Normal[2] = ((threex-onex)*(twoy-oney)) - ((twox-onex)*(threey-oney));	
+	onex   = Vertex[auxleaf.vertsLeaf[0]][0]; oney   = Vertex[auxleaf.vertsLeaf[0]][1]; onez   = Vertex[auxleaf.vertsLeaf[0]][2];
+	twox   = Vertex[auxleaf.vertsLeaf[1]][0]; twoy   = Vertex[auxleaf.vertsLeaf[1]][1]; twoz   = Vertex[auxleaf.vertsLeaf[1]][2];
+	threex = Vertex[auxleaf.vertsLeaf[2]][0]; threey = Vertex[auxleaf.vertsLeaf[2]][1]; threez = Vertex[auxleaf.vertsLeaf[2]][2];
+	
+	auxleaf.normal[0] = ((twoz-onez)*(threey-oney)) - ((twoy-oney)*(threez-onez));
+	auxleaf.normal[1] = ((twox-onex)*(threez-onez)) - ((threex-onex)*(twoz-onez));
+	auxleaf.normal[2] = ((threex-onex)*(twoy-oney)) - ((twox-onex)*(threey-oney));	
 }
 
@@ -296,14 +296,14 @@
 	float dist1, dist2, dist3, dist4, distmp, dista, distb, dist;
 
-	onex=Vertex[leaf1.Vert_Hoja[0]][0]; oney= Vertex[leaf1.Vert_Hoja[0]][1]; onez = Vertex[leaf1.Vert_Hoja[0]][2];
-	twox = Vertex[leaf1.Vert_Hoja[1]][0]; twoy = Vertex[leaf1.Vert_Hoja[1]][1]; twoz = Vertex[leaf1.Vert_Hoja[1]][2];
-	threex = Vertex[leaf1.Vert_Hoja[2]][0]; threey = Vertex[leaf1.Vert_Hoja[2]][1]; threez = Vertex[leaf1.Vert_Hoja[2]][2];
-	fourx = Vertex[leaf1.Vert_Hoja[3]][0]; foury = Vertex[leaf1.Vert_Hoja[3]][1]; fourz = Vertex[leaf1.Vert_Hoja[3]][2];
-	
-
-	x1 = Vertex[leaf2.Vert_Hoja[0]][0]; y1 = Vertex[leaf2.Vert_Hoja[0]][1]; z1 = Vertex[leaf2.Vert_Hoja[0]][2];
-	x2 = Vertex[leaf2.Vert_Hoja[1]][0]; y2 = Vertex[leaf2.Vert_Hoja[1]][1]; z2 = Vertex[leaf2.Vert_Hoja[1]][2];
-	x3 = Vertex[leaf2.Vert_Hoja[2]][0]; y3 = Vertex[leaf2.Vert_Hoja[2]][1]; z3 = Vertex[leaf2.Vert_Hoja[2]][2];
-	x4 = Vertex[leaf2.Vert_Hoja[3]][0]; y4 = Vertex[leaf2.Vert_Hoja[3]][1]; z4 = Vertex[leaf2.Vert_Hoja[3]][2];
+	onex=Vertex[leaf1.vertsLeaf[0]][0]; oney= Vertex[leaf1.vertsLeaf[0]][1]; onez = Vertex[leaf1.vertsLeaf[0]][2];
+	twox = Vertex[leaf1.vertsLeaf[1]][0]; twoy = Vertex[leaf1.vertsLeaf[1]][1]; twoz = Vertex[leaf1.vertsLeaf[1]][2];
+	threex = Vertex[leaf1.vertsLeaf[2]][0]; threey = Vertex[leaf1.vertsLeaf[2]][1]; threez = Vertex[leaf1.vertsLeaf[2]][2];
+	fourx = Vertex[leaf1.vertsLeaf[3]][0]; foury = Vertex[leaf1.vertsLeaf[3]][1]; fourz = Vertex[leaf1.vertsLeaf[3]][2];
+	
+
+	x1 = Vertex[leaf2.vertsLeaf[0]][0]; y1 = Vertex[leaf2.vertsLeaf[0]][1]; z1 = Vertex[leaf2.vertsLeaf[0]][2];
+	x2 = Vertex[leaf2.vertsLeaf[1]][0]; y2 = Vertex[leaf2.vertsLeaf[1]][1]; z2 = Vertex[leaf2.vertsLeaf[1]][2];
+	x3 = Vertex[leaf2.vertsLeaf[2]][0]; y3 = Vertex[leaf2.vertsLeaf[2]][1]; z3 = Vertex[leaf2.vertsLeaf[2]][2];
+	x4 = Vertex[leaf2.vertsLeaf[3]][0]; y4 = Vertex[leaf2.vertsLeaf[3]][1]; z4 = Vertex[leaf2.vertsLeaf[3]][2];
 
 	dist1 = distan ( onex, oney,onez,x1,y1,z1);
@@ -414,5 +414,5 @@
 
 //  Calculate the Hausdorff distance (distance between point clouds) (Optimized)
-float TreeSimplifier::HausdorffOptimized(const Hoja &leaf1, const Hoja& leaf2) const
+float TreeSimplifier::HausdorffOptimized(const Leaf &leaf1, const Leaf& leaf2) const
 {
 	float onex, oney, onez;
@@ -426,13 +426,13 @@
 	float dist1, dist2, dist3, dist4, distmp, dista, distb, dist;
 
-	onex   = Vertex[leaf1.Vert_Hoja[0]][0]; oney   = Vertex[leaf1.Vert_Hoja[0]][1]; onez   = Vertex[leaf1.Vert_Hoja[0]][2];
-	twox   = Vertex[leaf1.Vert_Hoja[1]][0]; twoy   = Vertex[leaf1.Vert_Hoja[1]][1]; twoz   = Vertex[leaf1.Vert_Hoja[1]][2];
-	threex = Vertex[leaf1.Vert_Hoja[2]][0]; threey = Vertex[leaf1.Vert_Hoja[2]][1]; threez = Vertex[leaf1.Vert_Hoja[2]][2];
-	fourx  = Vertex[leaf1.Vert_Hoja[3]][0]; foury  = Vertex[leaf1.Vert_Hoja[3]][1]; fourz  = Vertex[leaf1.Vert_Hoja[3]][2];
-
-	x1 = Vertex[leaf2.Vert_Hoja[0]][0]; y1 = Vertex[leaf2.Vert_Hoja[0]][1]; z1 = Vertex[leaf2.Vert_Hoja[0]][2];
-	x2 = Vertex[leaf2.Vert_Hoja[1]][0]; y2 = Vertex[leaf2.Vert_Hoja[1]][1]; z2 = Vertex[leaf2.Vert_Hoja[1]][2];
-	x3 = Vertex[leaf2.Vert_Hoja[2]][0]; y3 = Vertex[leaf2.Vert_Hoja[2]][1]; z3 = Vertex[leaf2.Vert_Hoja[2]][2];
-	x4 = Vertex[leaf2.Vert_Hoja[3]][0]; y4 = Vertex[leaf2.Vert_Hoja[3]][1]; z4 = Vertex[leaf2.Vert_Hoja[3]][2];
+	onex   = Vertex[leaf1.vertsLeaf[0]][0]; oney   = Vertex[leaf1.vertsLeaf[0]][1]; onez   = Vertex[leaf1.vertsLeaf[0]][2];
+	twox   = Vertex[leaf1.vertsLeaf[1]][0]; twoy   = Vertex[leaf1.vertsLeaf[1]][1]; twoz   = Vertex[leaf1.vertsLeaf[1]][2];
+	threex = Vertex[leaf1.vertsLeaf[2]][0]; threey = Vertex[leaf1.vertsLeaf[2]][1]; threez = Vertex[leaf1.vertsLeaf[2]][2];
+	fourx  = Vertex[leaf1.vertsLeaf[3]][0]; foury  = Vertex[leaf1.vertsLeaf[3]][1]; fourz  = Vertex[leaf1.vertsLeaf[3]][2];
+
+	x1 = Vertex[leaf2.vertsLeaf[0]][0]; y1 = Vertex[leaf2.vertsLeaf[0]][1]; z1 = Vertex[leaf2.vertsLeaf[0]][2];
+	x2 = Vertex[leaf2.vertsLeaf[1]][0]; y2 = Vertex[leaf2.vertsLeaf[1]][1]; z2 = Vertex[leaf2.vertsLeaf[1]][2];
+	x3 = Vertex[leaf2.vertsLeaf[2]][0]; y3 = Vertex[leaf2.vertsLeaf[2]][1]; z3 = Vertex[leaf2.vertsLeaf[2]][2];
+	x4 = Vertex[leaf2.vertsLeaf[3]][0]; y4 = Vertex[leaf2.vertsLeaf[3]][1]; z4 = Vertex[leaf2.vertsLeaf[3]][2];
 
 	// variables used to cache distances
@@ -608,5 +608,5 @@
 	for (i = 0; i < countLeaves; i++)
 	{
-		if (Leaves[i].existe)
+		if (Leaves[i].exists)
 		{
 			if (mindist > Leaves[i].dist || which==-1)
@@ -631,5 +631,5 @@
 	for (i=0;i<countLeaves;i++)
 	{
-		if (Leaves[i].existe)
+		if (Leaves[i].exists)
 		{
 			if (i == countLeaves-1)
@@ -638,15 +638,15 @@
 				j =	i + 1;
 			
-			while (Leaves[j].existe == false)
+			while (Leaves[j].exists == false)
 				j++;
 			
-			cop	= Leaves[i].Coplanaridad(Leaves[j]);
-			Leaves[i].hoja_cop	=	j;
+			cop	= Leaves[i].Coplanarity(Leaves[j]);
+			Leaves[i].leafCop	=	j;
 			
 			for (j=0; j<countLeaves-1; j++)
 			{
-				if (( j != i) && (Leaves[j].existe))
+				if (( j != i) && (Leaves[j].exists))
 				{
-					coptmp	=	Leaves[i].Coplanaridad(Leaves[j]);
+					coptmp	=	Leaves[i].Coplanarity(Leaves[j]);
 
 					// Take the most coplanar: close to 1
@@ -654,5 +654,5 @@
 					{
 						cop	= coptmp;
-						Leaves[i].hoja_cop = j;
+						Leaves[i].leafCop = j;
 					}
 				}
@@ -729,11 +729,11 @@
 
 	// initialize all vertices to the first
-	xmax = Vertex[Leaves[0].Vert_Hoja[0]][0];
+	xmax = Vertex[Leaves[0].vertsLeaf[0]][0];
 	xmin = xmax;
 
-	ymax = Vertex[Leaves[0].Vert_Hoja[0]][1];
+	ymax = Vertex[Leaves[0].vertsLeaf[0]][1];
 	ymin = ymax;
 
-	zmax = Vertex[Leaves[0].Vert_Hoja[0]][2];
+	zmax = Vertex[Leaves[0].vertsLeaf[0]][2];
 	zmin = zmax;
 
@@ -753,12 +753,12 @@
 		for (j=0;j<4;j++)
 		{			
-			if ( xmax < Vertex[Leaves[i].Vert_Hoja[j]][0]) xmax = Vertex[Leaves[i].Vert_Hoja[j]][0];
-			if ( xmin > Vertex[Leaves[i].Vert_Hoja[j]][0]) xmin = Vertex[Leaves[i].Vert_Hoja[j]][0];
-
-			if ( ymax < Vertex[Leaves[i].Vert_Hoja[j]][1]) ymax = Vertex[Leaves[i].Vert_Hoja[j]][1];
-			if ( ymin > Vertex[Leaves[i].Vert_Hoja[j]][1]) ymin = Vertex[Leaves[i].Vert_Hoja[j]][1];
+			if ( xmax < Vertex[Leaves[i].vertsLeaf[j]][0]) xmax = Vertex[Leaves[i].vertsLeaf[j]][0];
+			if ( xmin > Vertex[Leaves[i].vertsLeaf[j]][0]) xmin = Vertex[Leaves[i].vertsLeaf[j]][0];
+
+			if ( ymax < Vertex[Leaves[i].vertsLeaf[j]][1]) ymax = Vertex[Leaves[i].vertsLeaf[j]][1];
+			if ( ymin > Vertex[Leaves[i].vertsLeaf[j]][1]) ymin = Vertex[Leaves[i].vertsLeaf[j]][1];
 			
-			if ( zmax < Vertex[Leaves[i].Vert_Hoja[j]][2]) zmax = Vertex[Leaves[i].Vert_Hoja[j]][2];
-			if ( zmin > Vertex[Leaves[i].Vert_Hoja[j]][2]) zmin = Vertex[Leaves[i].Vert_Hoja[j]][2];
+			if ( zmax < Vertex[Leaves[i].vertsLeaf[j]][2]) zmax = Vertex[Leaves[i].vertsLeaf[j]][2];
+			if ( zmin > Vertex[Leaves[i].vertsLeaf[j]][2]) zmin = Vertex[Leaves[i].vertsLeaf[j]][2];
 		}
 	}
@@ -802,6 +802,6 @@
 		{
 			//incializo criterio a un numero elevado
-			Leaves[i].criterio = 1000;
-			nhojasi = int(Leaves[i].Cuantas_hojas);
+			Leaves[i].criteria = 1000;
+			nhojasi = int(Leaves[i].parentLeafCount);
 			//coplanaridad
 			for ( j =0; j<countLeaves;j++)
@@ -813,5 +813,5 @@
 					// ES COMO MÁXIMO 1
 
-					nhojasj = int(Leaves[j].Cuantas_hojas);
+					nhojasj = int(Leaves[j].parentLeafCount);
 
 					if ( abs((nhojasi - nhojasj)) < 2)
@@ -826,7 +826,7 @@
 						criteriotmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 						//selecciono el criterio menor
-						if (Leaves[i].criterio > criteriotmp) 
+						if (Leaves[i].criteria > criteriotmp) 
 						{
-							Leaves[i].criterio = criteriotmp;
+							Leaves[i].criteria = criteriotmp;
 							Leaves[i].hoja_crit = j;
 						}
@@ -854,9 +854,9 @@
 		if ((Leaves[i].existe == true) && (i != hojanueva))
 		{	
-			nhojasi = int(Leaves[i].Cuantas_hojas);
+			nhojasi = int(Leaves[i].parentLeafCount);
 			//¿ SE HA DESACTIVADO LA HOJA_CRIT QUE GUARDABA LA HOJA?
 			if ( Leaves[Leaves[i].hoja_crit].existe == false)
 			{
-				Leaves[i].criterio = 1000;
+				Leaves[i].criteria = 1000;
 
 				//coplanaridad
@@ -869,5 +869,5 @@
 						// ES COMO MÁXIMO 1
 
-						nhojasj = int(Leaves[j].Cuantas_hojas);
+						nhojasj = int(Leaves[j].parentLeafCount);
 
 						if ( abs((nhojasi - nhojasj)) < 2)
@@ -884,7 +884,7 @@
 							criteriotmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 							//selecciono el criterio menor
-							if (Leaves[i].criterio > criteriotmp) 
+							if (Leaves[i].criteria > criteriotmp) 
 							{
-								Leaves[i].criterio = criteriotmp;
+								Leaves[i].criteria = criteriotmp;
 								Leaves[i].hoja_crit = j;
 							}
@@ -895,5 +895,5 @@
 			else
 			{ // CALCULARE SI EL CRITERIO CON ESTA HOJA ES MENOR QUE EL ANTERIOR
-				nhojasj = int(Leaves[hojanueva].Cuantas_hojas);
+				nhojasj = int(Leaves[hojanueva].parentLeafCount);
 
 				if ( abs((nhojasi - nhojasj)) < 2)
@@ -909,7 +909,7 @@
 					criteriotmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 					//selecciono el criterio menor
-					if (Leaves[i].criterio > criteriotmp) 
+					if (Leaves[i].criteria > criteriotmp) 
 					{	
-						Leaves[i].criterio = criteriotmp;
+						Leaves[i].criteria = criteriotmp;
 						Leaves[i].hoja_crit = hojanueva;
 					}
@@ -929,14 +929,14 @@
 		
 /*	while (Leaves[i].existe != true) i++;
-	mincrit = Leaves[i].criterio;
+	mincrit = Leaves[i].criteria;
 	which =i;
 	*/
 	for (int i=0;i<countLeaves;i++)
 	{
-		if (Leaves[i].existe)
-		{
-			if (mincrit>Leaves[i].criterio || which==-1)
+		if (Leaves[i].exists)
+		{
+			if (mincrit>Leaves[i].criteria || which==-1)
 			{
-				mincrit = Leaves[i].criterio;
+				mincrit = Leaves[i].criteria;
 				which = i;
 			}
@@ -948,5 +948,5 @@
 
 
-void TreeSimplifier::ChooseVertices(Hoja& leaf1, Hoja& leaf2, long int count)
+void TreeSimplifier::ChooseVertices(Leaf& leaf1, Leaf& leaf2, long int count)
 {
 	float a,b,c;
@@ -954,33 +954,33 @@
 	int indices[4];
 	
-	a = Vertex[leaf1.Vert_Hoja[0]][0];
-	b = Vertex[leaf1.Vert_Hoja[0]][1];
-	c = Vertex[leaf1.Vert_Hoja[0]][2];
-
-	dist[0] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
-		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
-
-	
-	a = Vertex[leaf1.Vert_Hoja[1]][0];
-	b = Vertex[leaf1.Vert_Hoja[1]][1];
-	c = Vertex[leaf1.Vert_Hoja[1]][2];
-
-	dist[1] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
-		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
-
-	a = Vertex[leaf1.Vert_Hoja[2]][0];
-	b = Vertex[leaf1.Vert_Hoja[2]][1];
-	c = Vertex[leaf1.Vert_Hoja[2]][2];
-
-	dist[2] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
-		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
-
-
-	a = Vertex[leaf1.Vert_Hoja[3]][0];
-	b = Vertex[leaf1.Vert_Hoja[3]][1];
-	c = Vertex[leaf1.Vert_Hoja[3]][2];
-
-	dist[3] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf2.Centro[1]-b)*(leaf2.Centro[1]-b)) +
-		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
+	a = Vertex[leaf1.vertsLeaf[0]][0];
+	b = Vertex[leaf1.vertsLeaf[0]][1];
+	c = Vertex[leaf1.vertsLeaf[0]][2];
+
+	dist[0] = ((leaf2.center[0]-a)*(leaf2.center[0]-a)) + ((leaf2.center[1]-b)*(leaf2.center[1]-b)) +
+		   ((leaf2.center[2]-c)*(leaf2.center[2]-c));
+
+	
+	a = Vertex[leaf1.vertsLeaf[1]][0];
+	b = Vertex[leaf1.vertsLeaf[1]][1];
+	c = Vertex[leaf1.vertsLeaf[1]][2];
+
+	dist[1] = ((leaf2.center[0]-a)*(leaf2.center[0]-a)) + ((leaf2.center[1]-b)*(leaf2.center[1]-b)) +
+		   ((leaf2.center[2]-c)*(leaf2.center[2]-c));
+
+	a = Vertex[leaf1.vertsLeaf[2]][0];
+	b = Vertex[leaf1.vertsLeaf[2]][1];
+	c = Vertex[leaf1.vertsLeaf[2]][2];
+
+	dist[2] = ((leaf2.center[0]-a)*(leaf2.center[0]-a)) + ((leaf2.center[1]-b)*(leaf2.center[1]-b)) +
+		   ((leaf2.center[2]-c)*(leaf2.center[2]-c));
+
+
+	a = Vertex[leaf1.vertsLeaf[3]][0];
+	b = Vertex[leaf1.vertsLeaf[3]][1];
+	c = Vertex[leaf1.vertsLeaf[3]][2];
+
+	dist[3] = ((leaf2.center[0]-a)*(leaf2.center[0]-a)) + ((leaf2.center[1]-b)*(leaf2.center[1]-b)) +
+		   ((leaf2.center[2]-c)*(leaf2.center[2]-c));
 
 	for ( int i=0;i<4;i++) indices[i]=i;
@@ -988,38 +988,38 @@
 	TwoGreater(dist, indices);
 	
-	Leaves[countLeaves].Vert_Hoja[0] = leaf1.Vert_Hoja[indices[0]]; 
-	Leaves[countLeaves].Vert_Hoja[1] = leaf1.Vert_Hoja[indices[1]]; 
-	
-
-	
-	a = Vertex[leaf2.Vert_Hoja[0]][0];
-	b = Vertex[leaf2.Vert_Hoja[0]][1];
-	c = Vertex[leaf2.Vert_Hoja[0]][2];
-
-	dist[0] = ((leaf1.Centro[0]-a)*(leaf1.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
-		   ((leaf1.Centro[2]-c)*(leaf1.Centro[2]-c));
-
-	
-	a = Vertex[leaf2.Vert_Hoja[1]][0];
-	b = Vertex[leaf2.Vert_Hoja[1]][1];
-	c = Vertex[leaf2.Vert_Hoja[1]][2];
-
-	dist[1] = ((leaf2.Centro[0]-a)*(leaf2.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
-		   ((leaf2.Centro[2]-c)*(leaf2.Centro[2]-c));
-
-	a = Vertex[leaf2.Vert_Hoja[2]][0];
-	b = Vertex[leaf2.Vert_Hoja[2]][1];
-	c = Vertex[leaf2.Vert_Hoja[2]][2];
-
-	dist[2] = ((leaf1.Centro[0]-a)*(leaf1.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
-		   ((leaf1.Centro[2]-c)*(leaf1.Centro[2]-c));
-
-
-	a = Vertex[leaf2.Vert_Hoja[3]][0];
-	b = Vertex[leaf2.Vert_Hoja[3]][1];
-	c = Vertex[leaf2.Vert_Hoja[3]][2];
-
-	dist[3] = ((leaf1.Centro[0]-a)*(leaf1.Centro[0]-a)) + ((leaf1.Centro[1]-b)*(leaf1.Centro[1]-b)) +
-		   ((leaf1.Centro[2]-c)*(leaf1.Centro[2]-c));
+	Leaves[countLeaves].vertsLeaf[0] = leaf1.vertsLeaf[indices[0]]; 
+	Leaves[countLeaves].vertsLeaf[1] = leaf1.vertsLeaf[indices[1]]; 
+	
+
+	
+	a = Vertex[leaf2.vertsLeaf[0]][0];
+	b = Vertex[leaf2.vertsLeaf[0]][1];
+	c = Vertex[leaf2.vertsLeaf[0]][2];
+
+	dist[0] = ((leaf1.center[0]-a)*(leaf1.center[0]-a)) + ((leaf1.center[1]-b)*(leaf1.center[1]-b)) +
+		   ((leaf1.center[2]-c)*(leaf1.center[2]-c));
+
+	
+	a = Vertex[leaf2.vertsLeaf[1]][0];
+	b = Vertex[leaf2.vertsLeaf[1]][1];
+	c = Vertex[leaf2.vertsLeaf[1]][2];
+
+	dist[1] = ((leaf2.center[0]-a)*(leaf2.center[0]-a)) + ((leaf1.center[1]-b)*(leaf1.center[1]-b)) +
+		   ((leaf2.center[2]-c)*(leaf2.center[2]-c));
+
+	a = Vertex[leaf2.vertsLeaf[2]][0];
+	b = Vertex[leaf2.vertsLeaf[2]][1];
+	c = Vertex[leaf2.vertsLeaf[2]][2];
+
+	dist[2] = ((leaf1.center[0]-a)*(leaf1.center[0]-a)) + ((leaf1.center[1]-b)*(leaf1.center[1]-b)) +
+		   ((leaf1.center[2]-c)*(leaf1.center[2]-c));
+
+
+	a = Vertex[leaf2.vertsLeaf[3]][0];
+	b = Vertex[leaf2.vertsLeaf[3]][1];
+	c = Vertex[leaf2.vertsLeaf[3]][2];
+
+	dist[3] = ((leaf1.center[0]-a)*(leaf1.center[0]-a)) + ((leaf1.center[1]-b)*(leaf1.center[1]-b)) +
+		   ((leaf1.center[2]-c)*(leaf1.center[2]-c));
 
 	for ( int i=0;i<4;i++) indices[i]=i;
@@ -1027,6 +1027,6 @@
 	TwoGreater(dist, indices);
 	
-	Leaves[countLeaves].Vert_Hoja[2] = leaf2.Vert_Hoja[indices[0]]; 
-	Leaves[countLeaves].Vert_Hoja[3] = leaf2.Vert_Hoja[indices[1]]; 
+	Leaves[countLeaves].vertsLeaf[2] = leaf2.vertsLeaf[indices[0]]; 
+	Leaves[countLeaves].vertsLeaf[3] = leaf2.vertsLeaf[indices[1]]; 
 
 
@@ -1043,18 +1043,18 @@
 
 	which=MinCriteria();
-	other = Leaves[which].hoja_crit;
+	other = Leaves[which].leafCrit;
 
 	//desactivo las hojas cercanas
-	Leaves[which].existe = false;
-	Leaves[other].existe = false;
+	Leaves[which].exists = false;
+	Leaves[other].exists = false;
 	//creo la hoja nueva
 
-	Leaves[countLeaves].hoja_cerca = -1;
+	Leaves[countLeaves].leafNear = -1;
 	Leaves[countLeaves].dist = 0;
-	Leaves[countLeaves].hoja_cop = -1;
+	Leaves[countLeaves].leafCop = -1;
 	Leaves[countLeaves].coplanar = 0;
 
-	Leaves[countLeaves].Cuantas_hojas = Leaves[which].Cuantas_hojas + Leaves[other].Cuantas_hojas;
-//	Leaves[countLeaves].Cuantas_hojas = 10;
+	Leaves[countLeaves].parentLeafCount = Leaves[which].parentLeafCount + Leaves[other].parentLeafCount;
+//	Leaves[countLeaves].parentLeafCount = 10;
 	ChooseVertices(Leaves[which], Leaves[other], countLeaves);
 	CalculateLeafCenter (Leaves[countLeaves]);
@@ -1066,5 +1066,5 @@
 	onode->leaves.push_back(countLeaves);
 
-/*	if (Leaves[countLeaves].Cuantas_hojas > 60 )
+/*	if (Leaves[countLeaves].parentLeafCount > 60 )
 	{
 			Leaves[countLeaves].existe = false;
@@ -1073,8 +1073,8 @@
 	else
 	{		*/
-     	Leaves[countLeaves].existe = true;
-		Leaves[countLeaves].criterio = 1000000.0f;
-		Leaves[countLeaves].id_triangulo[0] = countLeaves*2;
-		Leaves[countLeaves].id_triangulo[1] = countLeaves*2+1;
+     	Leaves[countLeaves].exists = true;
+		Leaves[countLeaves].criteria = 1000000.0f;
+		Leaves[countLeaves].idTriangle[0] = countLeaves*2;
+		Leaves[countLeaves].idTriangle[1] = countLeaves*2+1;
 
  		float area_leaf_i = CalculateLeafArea(Leaves[i])/diam;
@@ -1088,7 +1088,7 @@
 				int j = *it;*/
 
-				if (j != countLeaves && Leaves[j].existe)
+				if (j != countLeaves && Leaves[j].exists)
 				{
-					coptmp2 = Leaves[countLeaves].Coplanaridad(Leaves[j]); 
+					coptmp2 = Leaves[countLeaves].Coplanarity(Leaves[j]); 
 					coptmp = 1 - coptmp2;
 					//distmp2 = HausdorffOptimized(Leaves[countLeaves], Leaves[j]);
@@ -1098,10 +1098,10 @@
 					criteriatmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 					criteriatmp *= CalculateLeafArea(Leaves[j])/diam + area_leaf_i;
-					criteriatmp *= Leaves[j].Cuantas_hojas + Leaves[i].Cuantas_hojas;
+					criteriatmp *= Leaves[j].parentLeafCount + Leaves[i].parentLeafCount;
 					
-					if (Leaves[countLeaves].criterio > criteriatmp) 
+					if (Leaves[countLeaves].criteria > criteriatmp) 
 					{
-						Leaves[countLeaves].criterio = criteriatmp;
-						Leaves[countLeaves].hoja_crit = j;
+						Leaves[countLeaves].criteria = criteriatmp;
+						Leaves[countLeaves].leafCrit = j;
 					}
 				}
@@ -1112,14 +1112,14 @@
 	// Crear el paso de simplificación
 	Geometry::TreeSimplificationSequence::Step pasosimp;
-	pasosimp.mV0=Leaves[which].id_triangulo[0];
-	pasosimp.mV1=Leaves[which].id_triangulo[1];
-	pasosimp.mT0=Leaves[other].id_triangulo[0];
-	pasosimp.mT1=Leaves[other].id_triangulo[1];
+	pasosimp.mV0=Leaves[which].idTriangle[0];
+	pasosimp.mV1=Leaves[which].idTriangle[1];
+	pasosimp.mT0=Leaves[other].idTriangle[0];
+	pasosimp.mT1=Leaves[other].idTriangle[1];
 
 	// Nuevos vértices
-	pasosimp.mNewQuad[0]=Leaves[countLeaves].Vert_Hoja[0];
-	pasosimp.mNewQuad[1]=Leaves[countLeaves].Vert_Hoja[1];
-	pasosimp.mNewQuad[2]=Leaves[countLeaves].Vert_Hoja[2];
-	pasosimp.mNewQuad[3]=Leaves[countLeaves].Vert_Hoja[3];
+	pasosimp.mNewQuad[0]=Leaves[countLeaves].vertsLeaf[0];
+	pasosimp.mNewQuad[1]=Leaves[countLeaves].vertsLeaf[1];
+	pasosimp.mNewQuad[2]=Leaves[countLeaves].vertsLeaf[2];
+	pasosimp.mNewQuad[3]=Leaves[countLeaves].vertsLeaf[3];
 
 	// Insertar el paso de simplificación
@@ -1156,14 +1156,14 @@
 		ticks_since_last_update++;
 		
-		if (Leaves[j].existe)
+		if (Leaves[j].exists)
 		{
 //			if (index<6)
 //			{
-				mesh->mSubMesh[idMeshLeaves].mIndex[index]=Leaves[j].Vert_Hoja[0];
-				mesh->mSubMesh[idMeshLeaves].mIndex[index+1]=Leaves[j].Vert_Hoja[1];
-				mesh->mSubMesh[idMeshLeaves].mIndex[index+2]=Leaves[j].Vert_Hoja[2];
-				mesh->mSubMesh[idMeshLeaves].mIndex[index+3]=Leaves[j].Vert_Hoja[2];
-				mesh->mSubMesh[idMeshLeaves].mIndex[index+4]=Leaves[j].Vert_Hoja[1];
-				mesh->mSubMesh[idMeshLeaves].mIndex[index+5]=Leaves[j].Vert_Hoja[3];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index]=Leaves[j].vertsLeaf[0];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+1]=Leaves[j].vertsLeaf[1];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+2]=Leaves[j].vertsLeaf[2];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+3]=Leaves[j].vertsLeaf[2];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+4]=Leaves[j].vertsLeaf[1];
+				mesh->mSubMesh[idMeshLeaves].mIndex[index+5]=Leaves[j].vertsLeaf[3];
 /*			}
 			else
@@ -1312,8 +1312,8 @@
 			{
 				int idleaf = *it;
-				int idv0 = Leaves[idleaf].Vert_Hoja[0];
-				int idv1 = Leaves[idleaf].Vert_Hoja[1];
-				int idv2 = Leaves[idleaf].Vert_Hoja[2];
-				int idv3 = Leaves[idleaf].Vert_Hoja[3];
+				int idv0 = Leaves[idleaf].vertsLeaf[0];
+				int idv1 = Leaves[idleaf].vertsLeaf[1];
+				int idv2 = Leaves[idleaf].vertsLeaf[2];
+				int idv3 = Leaves[idleaf].vertsLeaf[3];
 
 				float * v0 = Vertex[idv0];
@@ -1358,8 +1358,8 @@
 		ticks_since_last_update++;
 		
-		if (Leaves[i].existe == true)
-		{
-			Leaves[i].criterio = 1000000.0f;
-			nleavesi = int(Leaves[i].Cuantas_hojas);
+		if (Leaves[i].exists == true)
+		{
+			Leaves[i].criteria = 1000000.0f;
+			nleavesi = int(Leaves[i].parentLeafCount);
  			float area_leaf_i = CalculateLeafArea(Leaves[i])/diam;
 
@@ -1373,11 +1373,11 @@
 //				for (j=0; j<countLeaves; j++)
 //				{
-					if (j!=i && Leaves[j].existe)
+					if (j!=i && Leaves[j].exists)
 					{
-						nleavesj = int(Leaves[j].Cuantas_hojas);
+						nleavesj = int(Leaves[j].parentLeafCount);
 
 	//					if ( abs((nleavesi - nleavesj)) < 2)
 	//					{							
-							coptmp2 = Leaves[i].Coplanaridad(Leaves[j]);
+							coptmp2 = Leaves[i].Coplanarity(Leaves[j]);
 							coptmp = 1 - coptmp2;
 
@@ -1390,9 +1390,9 @@
 							// select the lowest
 							criteriatmp *= CalculateLeafArea(Leaves[j])/diam + area_leaf_i;
-							criteriatmp *= Leaves[j].Cuantas_hojas + Leaves[i].Cuantas_hojas;
-							if (Leaves[i].criterio > criteriatmp)
+							criteriatmp *= Leaves[j].parentLeafCount + Leaves[i].parentLeafCount;
+							if (Leaves[i].criteria > criteriatmp)
 							{
-								Leaves[i].criterio = criteriatmp;
-								Leaves[i].hoja_crit = j;
+								Leaves[i].criteria = criteriatmp;
+								Leaves[i].leafCrit = j;
 							}
 		//				}
@@ -1412,11 +1412,11 @@
 	for (i = 0; i < countLeaves; i++)
 	{
-		if (Leaves[i].existe && i!=newleaf)
+		if (Leaves[i].exists && i!=newleaf)
 		{	
  			float area_leaf_i = CalculateLeafArea(Leaves[i])/diam;
-			nleavesi = int(Leaves[i].Cuantas_hojas);
-			if ( Leaves[Leaves[i].hoja_crit].existe == false)
+			nleavesi = int(Leaves[i].parentLeafCount);
+			if ( Leaves[Leaves[i].leafCrit].exists == false)
 			{
-				Leaves[i].criterio = 1000000.0f;
+				Leaves[i].criteria = 1000000.0f;
 
 				int visit_parents = VISIT_PARENTS_DEEP;
@@ -1428,11 +1428,11 @@
 	//			for (j=0; j<countLeaves; j++)
 	//			{
-						if (j!=i && Leaves[j].existe)
+						if (j!=i && Leaves[j].exists)
 						{
-							nleavesj = int(Leaves[j].Cuantas_hojas);
+							nleavesj = int(Leaves[j].parentLeafCount);
 
 //							if ( abs((nleavesi - nleavesj)) < 2)
 //							{
-								coptmp2 = Leaves[i].Coplanaridad(Leaves[j]); 
+								coptmp2 = Leaves[i].Coplanarity(Leaves[j]); 
 								coptmp = 1 - coptmp2;	
 							
@@ -1444,11 +1444,11 @@
 								criteriatmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 								criteriatmp *= CalculateLeafArea(Leaves[j])/diam + area_leaf_i;
-								criteriatmp *= Leaves[j].Cuantas_hojas + Leaves[i].Cuantas_hojas;
+								criteriatmp *= Leaves[j].parentLeafCount + Leaves[i].parentLeafCount;
 								
 								// select the leaf with the lowest criteria
-								if (Leaves[i].criterio > criteriatmp) 
+								if (Leaves[i].criteria > criteriatmp) 
 								{
-									Leaves[i].criterio = criteriatmp;
-									Leaves[i].hoja_crit = j;
+									Leaves[i].criteria = criteriatmp;
+									Leaves[i].leafCrit = j;
 								}
 						//	}
@@ -1459,9 +1459,9 @@
 			else
 			{ 
-				nleavesj = int(Leaves[newleaf].Cuantas_hojas);
+				nleavesj = int(Leaves[newleaf].parentLeafCount);
 
 //				if ( abs((nleavesi - nleavesj)) < 2)
 //				{
-					coptmp2 = Leaves[i].Coplanaridad(Leaves[newleaf]); 
+					coptmp2 = Leaves[i].Coplanarity(Leaves[newleaf]); 
 					coptmp = 1 - coptmp2;
 
@@ -1472,10 +1472,10 @@
 					criteriatmp = (( K1 * distmp * distmp ) + (K2 * coptmp * distmp))/ (K1 + K2);
 					criteriatmp *= CalculateLeafArea(Leaves[newleaf])/diam + area_leaf_i;
-					criteriatmp *= Leaves[newleaf].Cuantas_hojas + Leaves[i].Cuantas_hojas;
+					criteriatmp *= Leaves[newleaf].parentLeafCount + Leaves[i].parentLeafCount;
 					
-					if (Leaves[i].criterio > criteriatmp) 
+					if (Leaves[i].criteria > criteriatmp) 
 					{	
-						Leaves[i].criterio = criteriatmp;
-						Leaves[i].hoja_crit = newleaf;
+						Leaves[i].criteria = criteriatmp;
+						Leaves[i].leafCrit = newleaf;
 					}
 //				}
@@ -1486,10 +1486,10 @@
 
 
-LeafOctree *TreeSimplifier::GetMinOctreeNodeForLeaf(LeafOctree *start, const Hoja &leaf)
-{
-	int idv0 = leaf.Vert_Hoja[0];
-	int idv1 = leaf.Vert_Hoja[1];
-	int idv2 = leaf.Vert_Hoja[2];
-	int idv3 = leaf.Vert_Hoja[3];
+LeafOctree *TreeSimplifier::GetMinOctreeNodeForLeaf(LeafOctree *start, const Leaf &leaf)
+{
+	int idv0 = leaf.vertsLeaf[0];
+	int idv1 = leaf.vertsLeaf[1];
+	int idv2 = leaf.vertsLeaf[2];
+	int idv3 = leaf.vertsLeaf[3];
 
 	float * v0 = Vertex[idv0];
@@ -1517,5 +1517,5 @@
 }
 
-float TreeSimplifier::DistanceFromCenters(const Hoja &leaf1, const Hoja &leaf2) const
+float TreeSimplifier::DistanceFromCenters(const Leaf &leaf1, const Leaf &leaf2) const
 {
 	float onex, oney, onez;
@@ -1528,8 +1528,8 @@
 	float x4, y4, z4;
 
-	onex   = Vertex[leaf1.Vert_Hoja[0]][0]; oney   = Vertex[leaf1.Vert_Hoja[0]][1]; onez   = Vertex[leaf1.Vert_Hoja[0]][2];
-	twox   = Vertex[leaf1.Vert_Hoja[1]][0]; twoy   = Vertex[leaf1.Vert_Hoja[1]][1]; twoz   = Vertex[leaf1.Vert_Hoja[1]][2];
-	threex = Vertex[leaf1.Vert_Hoja[2]][0]; threey = Vertex[leaf1.Vert_Hoja[2]][1]; threez = Vertex[leaf1.Vert_Hoja[2]][2];
-	fourx  = Vertex[leaf1.Vert_Hoja[3]][0]; foury  = Vertex[leaf1.Vert_Hoja[3]][1]; fourz  = Vertex[leaf1.Vert_Hoja[3]][2];
+	onex   = Vertex[leaf1.vertsLeaf[0]][0]; oney   = Vertex[leaf1.vertsLeaf[0]][1]; onez   = Vertex[leaf1.vertsLeaf[0]][2];
+	twox   = Vertex[leaf1.vertsLeaf[1]][0]; twoy   = Vertex[leaf1.vertsLeaf[1]][1]; twoz   = Vertex[leaf1.vertsLeaf[1]][2];
+	threex = Vertex[leaf1.vertsLeaf[2]][0]; threey = Vertex[leaf1.vertsLeaf[2]][1]; threez = Vertex[leaf1.vertsLeaf[2]][2];
+	fourx  = Vertex[leaf1.vertsLeaf[3]][0]; foury  = Vertex[leaf1.vertsLeaf[3]][1]; fourz  = Vertex[leaf1.vertsLeaf[3]][2];
 
 	float center1x = (onex + twox + threex + fourx)*0.25f;
